/* global vars */

var _round,_players,_questions,_answers,_currPlayer,_currQuestion,_currAnswers,_playersIn,_playersOut,_pointsPerQuestion;



$(document).ready(function () {
    _round = 1;
    _pointsPerQuestion = 3;
    
    getPlayers();
    getQuestions();

    $("#menu-toggle").click(function(e) {
        e.preventDefault();
        $("#wrapper").toggleClass("toggled");
    });
    $("#comodin-toggle").click(function(e) {
        e.preventDefault();
        useComodin();
    });
    $("#check-toggle").click(function(e) {
        e.preventDefault();
        checkAnswer();
    });
    $("#next-toggle").click(function(e) {
        e.preventDefault();
        nextQuestion();
    });
    
    $('#answers-panel .list-group-item').on('click',function(){
        
        $('#answers-panel .list-group-item').removeClass('selected');
        
        var $input = $(this).find('input[type=radio]');  
        if( $input.is(':checked') )  {
            $input.prop( "checked", false );
        }else{
            $input.prop( "checked", true );
            $(this).addClass('selected');
        }
        
         $("#check-toggle").removeClass('disabled');
    });
    
    $('#answer-result').on('click',function(e){
        e.preventDefault();
        $('#answer-result').modal('hide');
    });
    
 });

 
 /* ========================================================= */
 /* PLAYERS */
 
 
// get, paint & randomize players
function getPlayers(){
    $.ajax({
        type: "GET",
        url: "xml/players.xml",
        dataType: "xml",
        success: function (xml) {
                // XML/DOM to JSON  
                var x2js = new X2JS();
                var jsonObj = x2js.xml2json( xml );
                
                _players = jsonObj.players.player;
                
                _playersIn = [];
                _playersOut = [];
                
                var playerListItem = "";                
                
                for(var i = 0; i<_players.length;i++){
                    _playersIn[i] = _players[i];
                    
                    playerListItem += '<li class="list-group-item" id="player_'+_players[i]._id+'">\
                                        <span class="badge">0</span>'+ _players[i]._name + '</li>'; 
                }
                $("#players-list").append(playerListItem);                     
                $("#players-list").randomize();
        }
    });
 }
 
 
 
 
 /* ========================================================= */
 /* QUESTIONS */
 
// 
/** 
 * Get questions
 * <question> 
 * _id    Id question
 * _word  Question
 * __text Answer
*/
function getQuestions(){
    $.ajax({
        type: "GET",
        url: "xml/questions.xml",
        dataType: "xml",
        success: function (xml) {
        
                // XML/DOM to JSON  
                var x2js = new X2JS();
                var jsonObj = x2js.xml2json( xml ); 
                
                _questions = jsonObj.questions.question; 

                _answers = [];
                for(var i=0;i<_questions.length;i++){
                    _answers[i] = _questions[i]; 
                }

                renderQuestion();


        }
    });
 }

 function renderQuestion(){
    selectPlayer();
    selectQuestion();
    selectAnswers();
    updateScreen();

        
 }
 function updateScreen(){ 
    $('#game-status span.quest').text(_questions.length);
    $('#game-status span.answ').text(_answers.length);
    $('#game-status span.round').text(_round)
    $('#answers-panel .list-group-item.selected').removeClass('selected');
    $('#answers-panel .list-group-item').find('input[type=radio]').prop( "checked", false );  
    $('#answers-panel .list-group-item').removeClass('disabled');
    $('#next-toggle').addClass('disabled');
    $('#check-toggle').addClass('disabled');  
    $("#comodin-toggle").removeClass('disabled');
    $( '#answers-panel').removeClass('noclick');
    _pointsPerQuestion = 3;
}
 
 
 
 function selectPlayer(){
 
    if (typeof _currPlayer !== "undefined") {
        _playersOut.push(_currPlayer); 
    }
   
   // new round
    if (_playersIn.length == 0){
        _playersIn = _playersOut;
        _playersOut = [];
        _playersOut.push(_currPlayer); 
        _round = _round +1;
        $('.round').text(_round);
    }   
 
    var n = getRandomNum(_playersIn.length);
    _currPlayer = _playersIn[n]; 
    _playersIn.splice(n, 1);/*no deberia restar aquí..*/

    $("#players-list li").removeClass('active');
    $("#player_"+_currPlayer._id).addClass('active');  

    playerRoulete();
        
 }
 
 
 
 function selectQuestion(){ 
     var n = getRandomNum(_questions.length);
    _currQuestion = _questions[n];
    
     var qId     = _currQuestion._id;
     var qWord   = _currQuestion._word;
     var qAnswer = _currQuestion.__text;  
     
     //paint
     $('#questions-panel .panel-body').html(qWord);     
    
 }


 function selectAnswers(){
    var answ = [];

    // omite active question
    for(var i = 0; i < _answers.length; i++){
        if (_answers[i] && _answers[i]._id !== _currQuestion._id){
            answ.push(_answers[i]);
        }
    }   
    
    // random 
    answ.sort( function() { return 0.5 - Math.random() } );

    var answ1 = answ[0],
        answ2 = answ[1],
        answ3 = answ[2];
     
     //set answers
    _currAnswers = [];
    _currAnswers[0] = [_currQuestion._id, _currQuestion.__text];
    _currAnswers[1] = [answ1._id, answ1.__text];
    _currAnswers[2] = [answ2._id, answ2.__text];
    _currAnswers[3] = [answ3._id, answ3.__text];

     //random
     _currAnswers.sort( function() { return 0.5 - Math.random() } );
     
     //paint
     $('#answers-panel .list-group li.list-group-item').each(function( index ) {
        var id  = _currAnswers[index][0];
        var txt = _currAnswers[index][1];     
        $( this ).find('h2').text(txt);
        $( this ).find( 'input[name="answer"]').val(id);
     });
 }
 
 
 function checkAnswer(){
     
     var idAnswer = $( '#answers-panel .list-group li.list-group-item' ).find( 'input[type="radio"]:checked').val();
     
    $('#answer-result').find('img').hide();
        
    if (idAnswer == _currQuestion._id){
     
        // CORRECT!
        var n = getRandomNum(5) + 1;
        $('#answer-result').find('.ok').attr('src','img/ok'+ n +'.gif').show();
        $('#answer-result').modal('show');
       
        //remove question  
        for(var i = 0; i < _questions.length; i++){
            if (_questions[i] && _questions[i]._id === _currQuestion._id){            
                _questions.splice(i, 1);
                break;
            }
        }
        //suma a player
        sumaPuntos();
        
        $('#next-toggle').removeClass('disabled');
        $('#comodin-toggle').addClass('disabled');
        $('#check-toggle').addClass('disabled');
        $( '#answers-panel').addClass('noclick');
        
     }else{
        // OOOH!
        var n = getRandomNum(5) + 1;
        $('#answer-result').find('.ko').attr('src','img/ko'+ n +'.gif').show();
        $('#answer-result').modal('show');
        
        $('#next-toggle').removeClass('disabled');
        $('#check-toggle').addClass('disabled');
     }
 
 }
 
 
 function nextQuestion(){
 
  if(_questions.length > 0 ){
        renderQuestion();
    }else{
        alert('GAME END');
    }
 }

 function sumaPuntos(){     
     _currPlayer._points = parseInt(_currPlayer._points + _pointsPerQuestion); 
     $("#player_"+_currPlayer._id).find('.badge').text(_currPlayer._points);
 }


 
 function useComodin(){
  
    var $listAnswers = $( '#answers-panel .list-group li.list-group-item');
    var posibleAnswers = [];
    
    $listAnswers.each( function (index) {
       var thisval = $(this).find( 'input[type="radio"]').val();
       if (thisval != _currQuestion._id){ 
           posibleAnswers.push(index);
       }
    });
    
    var n = getRandomNum(posibleAnswers.length); 
    posibleAnswers.splice(n,1);
    
    for(var i = 0;i<posibleAnswers.length;i++){
        var index = posibleAnswers[i];
        $( '#answers-panel .list-group li.list-group-item:eq('+index+')').addClass('disabled');
    }
    _pointsPerQuestion = 1;
     
    $("#comodin-toggle").addClass('disabled');
 }
 


 function playerRoulete(){
 
    $('#player-result .modal-body h1').css('color','white');
    $('#player-result').modal('show');
 
    $.each(_playersIn, function (index, value) {
    
        setTimeout(function(){
           $('#player-result .modal-body h1').html(value._name);
           
           if(index == _playersIn.length-1){
                $('#player-result .modal-body h1').css('color','#C7F464').html(_currPlayer._name);
                $('.playerName').html(_currPlayer._name);
                 setTimeout(function(){  $('#player-result').modal('hide'); },2000);
            }        
        },150 + ( index * 150 ));         

    });
   
}

  
 function getRandomNum(n){
     return Math.floor((Math.random() * n));
 }
 
 function getQuestion(id){
    return _questions[id];
 }
 

/** 
* Randomize List Items 
*  
* $(parent_selector).randomize(child_selector);
* OR
* $(child_selector).randomize();
*
* http://stackoverflow.com/questions/1533910/randomize-a-sequence-of-div-elements-with-jquery#11766418
*/

$.fn.randomize = function(selector){
    var $elems = selector ? $(this).find(selector) : $(this).children(),
        $parents = $elems.parent();

    $parents.each(function(){
        $(this).children(selector).sort(function(){
            return Math.round(Math.random()) - 0.5;
        }).detach().appendTo(this);
    });

    return this;
};

